# Add rows

Inserts one or more rows into the sheet specified in the URL. If you want to insert the rows in any position but the default, use location-specifiers (that is, toTop, toBottom, parentId, siblingId, above, indent, outdent). See sample code tabs for variations in syntax.

If you want to implicitly create an empty cell, you can simply omit that cell. If you want to explicitly create an empty cell for a cell that holds an object, set the cell's objectValue to null. 

Note: This operation doesn't add rows with cells that have images. However, after the cell exists in a sheet, you can upload an image to a cell using the Add Image to Cell operation.

This operation supports both single-object and bulk semantics. For more information, refer to Optional Bulk Operations.

Endpoint: POST /sheets/{sheetId}/rows
Version: 2.0.0
Security: APIToken, OAuth2

## Path parameters:

  - `sheetId` (number, required)
    ID of the sheet being accessed.

## Header parameters:

  - `Authorization` (string)
    API Access Token used to authenticate requests to Smartsheet APIs.

  - `smartsheet-integration-source` (string)
    Uses the following metadata to distinguish between human-initiated API requests and third-party service-initiated calls by AI Connectors or ITSM:

- Integration source type
- Organization name
- Integration source name 

Format:


TYPE,OrgName,SourceName


Examples: 

AI,SampleOrg,My-AI-Connector-v2

SCRIPT,SampleOrg2,Accounting-updater-script

APPLICATION,SampleOrg3,SheetUpdater
    Example: "AI,SampleOrg,My-AI-Connector-v2"

  - `Content-Type` (string)
    Required for POST and PUT requests. Defines the structure for the request body.

## Query parameters:

  - `accessApiLevel` (number)
    Allows COMMENTER access for inputs and return values. For backwards-compatibility, VIEWER is the default. For example, to see whether a user has COMMENTER access for a sheet, use accessApiLevel=1.

  - `allowPartialSuccess` (boolean)
    When specified with a value of true, enables partial success for this bulk operation. See Bulk operations > Partial success for more information.

  - `overrideValidation` (boolean)
    You may use the query string parameter overrideValidation with a value of true to allow a cell value outside of the validation limits. You must specify strict with a value of false to bypass value type checking.

## Request fields (application/json):

  - `body` (Row (object) or Array of Row array (objects)) — one of:
    - Row:
      - `siblingId` (number)
        Identifies the row immediately above this row, if one exists.

If you use this property as the only location specifier in a write operation, this row is placed immediately below the siblingId row. If you include this property and an above property in a write operation, this row is placed immediately above the siblingId row. 

Note: In add/update row operations, siblingId can't be used with parentId.
      - `parentId` (number)
        Identifies a row that is the hierarchical parent of this row, if one exists.

If you use this property as the only location specifier in a write operation, this row becomes the child row immediately below the parentId row. If you include this property and a toBottom property in a write operation, this row becomes the last child below the parentId row.

Note: In add/update row operations, siblingId can't be used with parentId.
      - `toTop` (boolean)
        Places the row at the top of the sheet. This property can't be used with a siblingId property.
        Enum: true
      - `toBottom` (boolean)
        Use this property with a parentId property to make this row the last child below the parentId row.
        Enum: same as `toTop` in "Row" (1 values)
      - `above` (boolean)
        Use this property with a siblingId to place this row immediately above the siblingId row.
        Enum: same as `toTop` in "Row" (1 values)
      - `attachments` (array)
        Attachments on row. Only returned if the include query string parameter contains attachments.
      - `attachments.id` (number)
        Attachment ID.
      - `attachments.parentId` (number)
        The ID of the parent.
      - `attachments.attachmentType` (string)
        Attachment type. Note--Dropbox, Egnyte, and Evernote are not supported for Smartsheet.gov accounts.
        Enum: "BOX_COM", "DROPBOX", "EGNYTE", "EVERNOTE", "FILE", "GOOGLE_DRIVE", "LINK", "ONEDRIVE", "TRELLO"
      - `attachments.attachmentSubType` (string)
        Attachment sub type. Note--Folder type is for EGNYTE values and the rest are GOOGLE_DRIVE values.
        Enum: "DOCUMENT", "DRAWING", "FOLDER", "PDF", "PRESENTATION", "SPREADSHEET"
      - `attachments.mimeType` (string)
        Attachment MIME type.
        Example: "PNG"
      - `attachments.parentType` (string)
        The type of object the attachment belongs to.
        Enum: "COMMENT", "PROOF", "ROW", "SHEET"
      - `attachments.createdBy` (object)
        User object containing name and email of the user who created this attachment.
      - `attachments.createdBy.email` (string)
        Example: "jane.doe@smartsheet.com"
      - `attachments.name` (string)
        Attachment name.
      - `attachments.sizeInKb` (number)
        The size of the file, if the attachmentType is FILE.
      - `attachments.url` (string)
        Attachment temporary URL (files only).
      - `attachments.urlExpiresInMillis` (number)
        Attachment temporary URL time to live (files only).
      - `cells` (array)
        Cells belonging to the row.
      - `cells.columnId` (number)
        The ID of the column that the cell is located in.
      - `cells.columnType` (string)
        Only returned if the include query string parameter contains columnType.
      - `cells.conditionalFormat` (string)
        The format descriptor describing this cell's conditional format. Only returned if the include query string parameter contains format and this cell has a conditional format applied.

Refer to [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting), for format descriptor details.
      - `cells.displayValue` (string)
        Visual representation of cell contents, as presented to the user in the UI.
      - `cells.format` (string)
        The format descriptor. Only returned if the include query string parameter contains format and this cell has a non-default format applied.

Refer to [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting), for format descriptor details.
      - `cells.formula` (string)
        The formula for a cell, if set, for instance =COUNTM([Assigned To]3). 

Note that calculation errors or problems with a formula do not cause the API call to return an error code. Instead, the response contains the same value as in the UI, such as cell.value = "#CIRCULAR REFERENCE".
      - `cells.hyperlink` (object)
      - `cells.hyperlink.reportId` (number)
        If non-null, this hyperlink is a link to the report with this ID.
      - `cells.hyperlink.sheetId` (number)
        If non-null, this hyperlink is a link to the sheet with this ID.
      - `cells.hyperlink.sightId` (number)
        If non-null, this hyperlink is a link to the dashboard with this ID.
      - `cells.hyperlink.url` (string)
        When the hyperlink is a URL link, this property contains the URL value.

When the hyperlink is a dashboard/report/sheet link (that is, dashboardId, reportId, or sheetId is non-null), this property contains the permalink to the dashboard, report, or sheet.
      - `cells.image` (object)
      - `cells.image.altText` (string)
        Alternate text for the image.
      - `cells.image.height` (number)
        Original height (in pixels) of the uploaded image.
      - `cells.image.id` (string)
        Image ID.
      - `cells.image.width` (number)
        Original width (in pixels) of the uploaded image.
      - `cells.linkInFromCell` (object)
      - `cells.linkInFromCell.columnId` (number)
        Column ID of the linked cell.
      - `cells.linkInFromCell.rowId` (number)
        Row ID of the linked cell.
      - `cells.linkInFromCell.sheetId` (number)
        Sheet ID of the sheet that the linked cell belongs to.
      - `cells.linkInFromCell.sheetName` (string)
        Sheet name of the linked cell.
      - `cells.linkInFromCell.status` (string)
        * BLOCKED One of several other values indicating unusual error conditions.
* BROKEN The row or sheet linked to was deleted.
* CIRCULAR One of several other values indicating unusual error conditions.
* DISABLED One of several other values indicating unusual error conditions.
* INACCESSIBLE The sheet linked to cannot be viewed by this user.
* INVALID One of several other values indicating unusual error conditions.
* NOT_SHARED One of several other values indicating unusual error conditions.
* OK The link is in a good state.
        Enum: "BLOCKED", "BROKEN", "CIRCULAR", "DISABLED", "INACCESSIBLE", "INVALID", "NOT_SHARED", "OK"
      - `cells.linksOutToCells` (array)
      - `cells.objectValue` (any) — one of:
        - Abstract datetime object value:
          - `objectType` (string)
            Enum: "ABSTRACT_DATETIME"
          - `value` (string)
            Datetime, in the date-time format defined by RFC 3339, section 5.6
        - Contact object value:
          - `objectType` (string)
            Enum: "CONTACT"
          - `email` (string)
            Email address of the Contact
            Example: "john.doe@acme.com"
          - `name` (string)
            Name of the Contact
            Example: "John Doe"
          - `imageId` (string)
            ID of an image associated with the Contact
            Example: "1234!_qwer!_5667zxcvQWER!_ASDF"
          - `emailId` (string)
            ID of the email address
            Example: "23456789"
          - `userId` (string)
            User ID of the contact
            Example: "12345678"
          - `lookUpName` (boolean)
            Whether or not to look up the contact's name based on their email address.
            Example: true
        - Date object value:
          - `objectType` (string)
            Enum: "DATE"
          - `value` (string)
            Date in the full-date format defined by RFC 3339, section 5.6.

If you want to make the cell empty, set objectValue to null rather than objectValue.value; setting objectValue.value to null results in an error.
        - Datetime object value:
          - `objectType` (string)
            Enum: "DATETIME"
          - `value` (string)
            Datetime, in the date-time format defined by RFC 3339, section 5.6.

If you want to make the cell empty, set objectValue to null rather than objectValue.value; setting objectValue.value to null results in an error.
        - Duration object value:
          - `objectType` (string)
            Enum: "DURATION"
          - `days` (number)
            Number of days
        - Multi-contact object value:
          - `objectType` (string)
            Enum: "MULTI_CONTACT"
          - `values` (array)
            List of contacts.

If you want to make the cell empty, set objectValue to null rather than objectValue.values; setting objectValue.values to null results in an error.
          - `values.objectType` (string)
            Enum: same as `objectType` in "Contact object value" (1 values)
          - `values.email` (string)
            Email address of the Contact
            Example: "john.doe@acme.com"
          - `values.name` (string)
            Name of the Contact
            Example: "John Doe"
          - `values.imageId` (string)
            ID of an image associated with the Contact
            Example: "1234!_qwer!_5667zxcvQWER!_ASDF"
          - `values.emailId` (string)
            ID of the email address
            Example: "23456789"
          - `values.userId` (string)
            User ID of the contact
            Example: "12345678"
          - `values.lookUpName` (boolean)
            Whether or not to look up the contact's name based on their email address.
            Example: true
        - Multi-picklist object value:
          - `objectType` (string)
            Enum: "MULTI_PICKLIST"
          - `values` (array)
            List of strings to choose from.

If you want to make the cell empty, set objectValue to null rather than objectValue.values; setting objectValue.values to null results in an error.
        - Predecessor list object value:
          - `objectType` (string)
            Enum: "PREDECESSOR_LIST"
          - `predecessors` (array)
            List of references to rows on which the current row depends
            Example: [{"rowId":1234567890123456,"rowNumber":2,"type":"FS","inCriticalPath":true}]
          - `predecessors.rowId` (number)
            The ID of the predecessor row.
            Example: 1234567890123456
          - `predecessors.type` (string)
            Type of the predecessor:
 * FF (Finish-to-Finish) - finish at the same time the predecessor finishes.
 * FS (Finish-to-Start) - start after the predecessor finishes.
 * SF (Start-to-Finish) - finish before the predecessor starts.
 * SS (Start-to-Start) - start at the same time the predecessor starts.
            Enum: "FF", "FS", "SF", "SS"
          - `predecessors.lag` (object)
            In a project sheet, represents a value in a duration cell, or a lag value of a predecessor.
          - `predecessors.lag.days` (number)
            The number of days for this duration.
          - `predecessors.lag.elapsed` (boolean)
            If true, indicates this duration represents elapsed time, which ignores non-working time.
          - `predecessors.lag.hours` (number)
            The number of hours for this duration.
          - `predecessors.lag.milliseconds` (number)
            The number of milliseconds for this duration.
          - `predecessors.lag.minutes` (number)
            The number of minutes for this duration.
          - `predecessors.lag.negative` (boolean)
            When used as a predecessor's lag value, indicates whether the lag is negative (if true), or positive (false). The individual duration values themselves (for example, days, hours, or minutes) is always positive.
          - `predecessors.lag.objectType` (string)
            Enum: same as `objectType` in "Duration object value" (1 values)
          - `predecessors.lag.seconds` (number)
            The number of seconds for this duration.
          - `predecessors.lag.weeks` (number)
            The number of weeks for this duration.
      - `cells.overrideValidation` (boolean)
        (Admin only) Indicates whether the cell value can contain a value outside of the validation limits (value = true). When using this parameter, you must also set strict to false to bypass value type checking. This property is honored for POST or PUT actions that update rows.
      - `cells.strict` (boolean)
        Set to false to enable lenient parsing. Defaults to true. You can specify this attribute in a request, but it is never present in a response.
      - `cells.value` (any)
        A string, number, or a Boolean value -- depending on the cell type and the data in the cell. Cell values larger than 4000 characters are silently truncated. An empty cell returns no value.
      - `conditionalFormat` (string)
        Describes this row's conditional format. Only returned if the include query string parameter contains format and this row has a conditional format applied.
        Example: ",,1,1,,,,,,,,,,,,,"
      - `discussions` (array)
        Discussions on the row. Only returned if the include query string parameter contains discussions.
      - `discussions.accessLevel` (string)
        Enum: "ADMIN", "COMMENTER", "EDITOR", "EDITOR_SHARE", "OWNER", "VIEWER"
      - `discussions.id` (number)
        Discussion ID.
      - `discussions.comments` (array)
        Array of comments in discussion. Only returned if the include query string parameter contains comments.
      - `discussions.comments.attachments` (array)
        Array of attachments on comments.
      - `discussions.comments.createdBy` (object)
        User object containing name and email of the creator of this comment.
      - `discussions.comments.createdBy.email` (string)
        Example: "jane.doe@smartsheet.com"
      - `discussions.comments.discussionId` (number)
        Discussion ID of discussion that contains comment.
      - `discussions.comments.id` (number)
        Comment ID.
      - `discussions.comments.text` (string)
        Comment body.
      - `discussions.commentAttachments` (array)
        Array of attachments on discussion comments. Only returned if the include query string parameter contains attachments.
      - `discussions.commentCount` (number)
        Number of comments in the discussion.
      - `discussions.createdBy` (object)
        User object containing name and email of the user who created the discussion.
      - `discussions.createdBy.email` (string)
        Example: "jane.doe@smartsheet.com"
      - `discussions.lastCommentedUser` (object)
        User object containing name and email of the user who last commented on the discussion.
      - `discussions.lastCommentedUser.email` (string)
        Example: "jane.doe@smartsheet.com"
      - `discussions.parentId` (number)
        The ID of the associated row or sheet.
      - `discussions.parentType` (string)
        Type of parent object.
        Enum: "ROW", "SHEET"
      - `discussions.readOnly` (boolean)
        Indicates whether the user can modify the discussion.
      - `proof` (object)
        Object containing zero or more media items, including images, videos, and documents, for review, editing, or approval.
      - `proof.id` (number)
        Proof ID of the proof version.
      - `proof.originalId` (number)
        Proof ID of the original proof version.
      - `proof.name` (string)
        Proof name. This is the same as primary column value. If the primary column value is empty, name is empty.
      - `proof.type` (string)
        File type for the proof version.
        Enum: "DOCUMENT", "IMAGE", "MIXED", "NONE", "VIDEO"
      - `proof.documentType` (string)
        If type=DOCUMENT, then this indicates the type of file, such as PDF.
      - `proof.proofRequestUrl` (string)
        URL to review a proofing request.
      - `proof.version` (number)
        The version number of the proof.
      - `proof.lastUpdatedBy` (object)
        User object containing name and email of the user who last updated the proof.
      - `proof.lastUpdatedBy.email` (string)
        Example: "jane.doe@smartsheet.com"
      - `proof.isCompleted` (boolean)
        Indicates whether the proof is completed.
      - `proof.attachments` (array)
        Array of Attachment objects. Only returned if the include query string parameter contains attachments.
      - `proof.discussions` (array)
        Array of Discussion objects. Only returned if the include query string parameter contains discussions.
      - `format` (string)
        Format descriptor. Only returned if the include query string parameter contains format and this row has a non-default format applied.

Refer to [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting), for format descriptor details.
        Example: ",,1,1,,,,,,,,,,,,,"
      - `inCriticalPath` (boolean)
        Only returned, with a value of true, if the sheet is a project sheet with dependencies enabled and this row is in the critical path.
      - `locked` (boolean)
        Indicates whether the row is locked.
      - `lockedForUser` (boolean)
        Indicates whether the row is locked for the requesting user.
    - Row array:
      - `siblingId` (number)
        Identifies the row immediately above this row, if one exists.

If you use this property as the only location specifier in a write operation, this row is placed immediately below the siblingId row. If you include this property and an above property in a write operation, this row is placed immediately above the siblingId row. 

Note: In add/update row operations, siblingId can't be used with parentId.
      - `parentId` (number)
        Identifies a row that is the hierarchical parent of this row, if one exists.

If you use this property as the only location specifier in a write operation, this row becomes the child row immediately below the parentId row. If you include this property and a toBottom property in a write operation, this row becomes the last child below the parentId row.

Note: In add/update row operations, siblingId can't be used with parentId.
      - `toTop` (boolean)
        Places the row at the top of the sheet. This property can't be used with a siblingId property.
        Enum: same as `toTop` in "Row" (1 values)
      - `toBottom` (boolean)
        Use this property with a parentId property to make this row the last child below the parentId row.
        Enum: same as `toTop` in "Row" (1 values)
      - `above` (boolean)
        Use this property with a siblingId to place this row immediately above the siblingId row.
        Enum: same as `toTop` in "Row" (1 values)
      - `attachments` (array)
        Attachments on row. Only returned if the include query string parameter contains attachments.
      - `attachments.id` (number)
        Attachment ID.
      - `attachments.parentId` (number)
        The ID of the parent.
      - `attachments.attachmentType` (string)
        Attachment type. Note--Dropbox, Egnyte, and Evernote are not supported for Smartsheet.gov accounts.
        Enum: same as `attachments.attachmentType` in "Row" (9 values)
      - `attachments.attachmentSubType` (string)
        Attachment sub type. Note--Folder type is for EGNYTE values and the rest are GOOGLE_DRIVE values.
        Enum: same as `attachments.attachmentSubType` in "Row" (6 values)
      - `attachments.mimeType` (string)
        Attachment MIME type.
        Example: "PNG"
      - `attachments.parentType` (string)
        The type of object the attachment belongs to.
        Enum: same as `attachments.parentType` in "Row" (4 values)
      - `attachments.createdBy` (object)
        User object containing name and email of the user who created this attachment.
      - `attachments.createdBy.email` (string)
        Example: "jane.doe@smartsheet.com"
      - `attachments.name` (string)
        Attachment name.
      - `attachments.sizeInKb` (number)
        The size of the file, if the attachmentType is FILE.
      - `attachments.url` (string)
        Attachment temporary URL (files only).
      - `attachments.urlExpiresInMillis` (number)
        Attachment temporary URL time to live (files only).
      - `cells` (array)
        Cells belonging to the row.
      - `cells.columnId` (number)
        The ID of the column that the cell is located in.
      - `cells.columnType` (string)
        Only returned if the include query string parameter contains columnType.
      - `cells.conditionalFormat` (string)
        The format descriptor describing this cell's conditional format. Only returned if the include query string parameter contains format and this cell has a conditional format applied.

Refer to [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting), for format descriptor details.
      - `cells.displayValue` (string)
        Visual representation of cell contents, as presented to the user in the UI.
      - `cells.format` (string)
        The format descriptor. Only returned if the include query string parameter contains format and this cell has a non-default format applied.

Refer to [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting), for format descriptor details.
      - `cells.formula` (string)
        The formula for a cell, if set, for instance =COUNTM([Assigned To]3). 

Note that calculation errors or problems with a formula do not cause the API call to return an error code. Instead, the response contains the same value as in the UI, such as cell.value = "#CIRCULAR REFERENCE".
      - `cells.hyperlink` (object)
      - `cells.hyperlink.reportId` (number)
        If non-null, this hyperlink is a link to the report with this ID.
      - `cells.hyperlink.sheetId` (number)
        If non-null, this hyperlink is a link to the sheet with this ID.
      - `cells.hyperlink.sightId` (number)
        If non-null, this hyperlink is a link to the dashboard with this ID.
      - `cells.hyperlink.url` (string)
        When the hyperlink is a URL link, this property contains the URL value.

When the hyperlink is a dashboard/report/sheet link (that is, dashboardId, reportId, or sheetId is non-null), this property contains the permalink to the dashboard, report, or sheet.
      - `cells.image` (object)
      - `cells.image.altText` (string)
        Alternate text for the image.
      - `cells.image.height` (number)
        Original height (in pixels) of the uploaded image.
      - `cells.image.id` (string)
        Image ID.
      - `cells.image.width` (number)
        Original width (in pixels) of the uploaded image.
      - `cells.linkInFromCell` (object)
      - `cells.linkInFromCell.columnId` (number)
        Column ID of the linked cell.
      - `cells.linkInFromCell.rowId` (number)
        Row ID of the linked cell.
      - `cells.linkInFromCell.sheetId` (number)
        Sheet ID of the sheet that the linked cell belongs to.
      - `cells.linkInFromCell.sheetName` (string)
        Sheet name of the linked cell.
      - `cells.linkInFromCell.status` (string)
        * BLOCKED One of several other values indicating unusual error conditions.
* BROKEN The row or sheet linked to was deleted.
* CIRCULAR One of several other values indicating unusual error conditions.
* DISABLED One of several other values indicating unusual error conditions.
* INACCESSIBLE The sheet linked to cannot be viewed by this user.
* INVALID One of several other values indicating unusual error conditions.
* NOT_SHARED One of several other values indicating unusual error conditions.
* OK The link is in a good state.
        Enum: same as `cells.linkInFromCell.status` in "Row" (8 values)
      - `cells.linksOutToCells` (array)
      - `cells.objectValue` (any) — one of:
        - Abstract datetime object value:
          - `objectType` (string)
            Enum: same as `objectType` in "Abstract datetime object value" (1 values)
          - `value` (string)
            Datetime, in the date-time format defined by RFC 3339, section 5.6
        - Contact object value:
          - `objectType` (string)
            Enum: same as `objectType` in "Contact object value" (1 values)
          - `email` (string)
            Email address of the Contact
            Example: "john.doe@acme.com"
          - `name` (string)
            Name of the Contact
            Example: "John Doe"
          - `imageId` (string)
            ID of an image associated with the Contact
            Example: "1234!_qwer!_5667zxcvQWER!_ASDF"
          - `emailId` (string)
            ID of the email address
            Example: "23456789"
          - `userId` (string)
            User ID of the contact
            Example: "12345678"
          - `lookUpName` (boolean)
            Whether or not to look up the contact's name based on their email address.
            Example: true
        - Date object value:
          - `objectType` (string)
            Enum: same as `objectType` in "Date object value" (1 values)
          - `value` (string)
            Date in the full-date format defined by RFC 3339, section 5.6.

If you want to make the cell empty, set objectValue to null rather than objectValue.value; setting objectValue.value to null results in an error.
        - Datetime object value:
          - `objectType` (string)
            Enum: same as `objectType` in "Datetime object value" (1 values)
          - `value` (string)
            Datetime, in the date-time format defined by RFC 3339, section 5.6.

If you want to make the cell empty, set objectValue to null rather than objectValue.value; setting objectValue.value to null results in an error.
        - Duration object value:
          - `objectType` (string)
            Enum: same as `objectType` in "Duration object value" (1 values)
          - `days` (number)
            Number of days
        - Multi-contact object value:
          - `objectType` (string)
            Enum: same as `objectType` in "Multi-contact object value" (1 values)
          - `values` (array)
            List of contacts.

If you want to make the cell empty, set objectValue to null rather than objectValue.values; setting objectValue.values to null results in an error.
          - `values.objectType` (string)
            Enum: same as `objectType` in "Contact object value" (1 values)
          - `values.email` (string)
            Email address of the Contact
            Example: "john.doe@acme.com"
          - `values.name` (string)
            Name of the Contact
            Example: "John Doe"
          - `values.imageId` (string)
            ID of an image associated with the Contact
            Example: "1234!_qwer!_5667zxcvQWER!_ASDF"
          - `values.emailId` (string)
            ID of the email address
            Example: "23456789"
          - `values.userId` (string)
            User ID of the contact
            Example: "12345678"
          - `values.lookUpName` (boolean)
            Whether or not to look up the contact's name based on their email address.
            Example: true
        - Multi-picklist object value:
          - `objectType` (string)
            Enum: same as `objectType` in "Multi-picklist object value" (1 values)
          - `values` (array)
            List of strings to choose from.

If you want to make the cell empty, set objectValue to null rather than objectValue.values; setting objectValue.values to null results in an error.
        - Predecessor list object value:
          - `objectType` (string)
            Enum: same as `objectType` in "Predecessor list object value" (1 values)
          - `predecessors` (array)
            List of references to rows on which the current row depends
            Example: [{"rowId":1234567890123456,"rowNumber":2,"type":"FS","inCriticalPath":true}]
          - `predecessors.rowId` (number)
            The ID of the predecessor row.
            Example: 1234567890123456
          - `predecessors.type` (string)
            Type of the predecessor:
 * FF (Finish-to-Finish) - finish at the same time the predecessor finishes.
 * FS (Finish-to-Start) - start after the predecessor finishes.
 * SF (Start-to-Finish) - finish before the predecessor starts.
 * SS (Start-to-Start) - start at the same time the predecessor starts.
            Enum: same as `predecessors.type` in "Predecessor list object value" (4 values)
          - `predecessors.lag` (object)
            In a project sheet, represents a value in a duration cell, or a lag value of a predecessor.
          - `predecessors.lag.days` (number)
            The number of days for this duration.
          - `predecessors.lag.elapsed` (boolean)
            If true, indicates this duration represents elapsed time, which ignores non-working time.
          - `predecessors.lag.hours` (number)
            The number of hours for this duration.
          - `predecessors.lag.milliseconds` (number)
            The number of milliseconds for this duration.
          - `predecessors.lag.minutes` (number)
            The number of minutes for this duration.
          - `predecessors.lag.negative` (boolean)
            When used as a predecessor's lag value, indicates whether the lag is negative (if true), or positive (false). The individual duration values themselves (for example, days, hours, or minutes) is always positive.
          - `predecessors.lag.objectType` (string)
            Enum: same as `objectType` in "Duration object value" (1 values)
          - `predecessors.lag.seconds` (number)
            The number of seconds for this duration.
          - `predecessors.lag.weeks` (number)
            The number of weeks for this duration.
      - `cells.overrideValidation` (boolean)
        (Admin only) Indicates whether the cell value can contain a value outside of the validation limits (value = true). When using this parameter, you must also set strict to false to bypass value type checking. This property is honored for POST or PUT actions that update rows.
      - `cells.strict` (boolean)
        Set to false to enable lenient parsing. Defaults to true. You can specify this attribute in a request, but it is never present in a response.
      - `cells.value` (any)
        A string, number, or a Boolean value -- depending on the cell type and the data in the cell. Cell values larger than 4000 characters are silently truncated. An empty cell returns no value.
      - `conditionalFormat` (string)
        Describes this row's conditional format. Only returned if the include query string parameter contains format and this row has a conditional format applied.
        Example: ",,1,1,,,,,,,,,,,,,"
      - `discussions` (array)
        Discussions on the row. Only returned if the include query string parameter contains discussions.
      - `discussions.accessLevel` (string)
        Enum: same as `discussions.accessLevel` in "Row" (6 values)
      - `discussions.id` (number)
        Discussion ID.
      - `discussions.comments` (array)
        Array of comments in discussion. Only returned if the include query string parameter contains comments.
      - `discussions.comments.attachments` (array)
        Array of attachments on comments.
      - `discussions.comments.createdBy` (object)
        User object containing name and email of the creator of this comment.
      - `discussions.comments.createdBy.email` (string)
        Example: "jane.doe@smartsheet.com"
      - `discussions.comments.discussionId` (number)
        Discussion ID of discussion that contains comment.
      - `discussions.comments.id` (number)
        Comment ID.
      - `discussions.comments.text` (string)
        Comment body.
      - `discussions.commentAttachments` (array)
        Array of attachments on discussion comments. Only returned if the include query string parameter contains attachments.
      - `discussions.commentCount` (number)
        Number of comments in the discussion.
      - `discussions.createdBy` (object)
        User object containing name and email of the user who created the discussion.
      - `discussions.createdBy.email` (string)
        Example: "jane.doe@smartsheet.com"
      - `discussions.lastCommentedUser` (object)
        User object containing name and email of the user who last commented on the discussion.
      - `discussions.lastCommentedUser.email` (string)
        Example: "jane.doe@smartsheet.com"
      - `discussions.parentId` (number)
        The ID of the associated row or sheet.
      - `discussions.parentType` (string)
        Type of parent object.
        Enum: same as `discussions.parentType` in "Row" (2 values)
      - `discussions.readOnly` (boolean)
        Indicates whether the user can modify the discussion.
      - `proof` (object)
        Object containing zero or more media items, including images, videos, and documents, for review, editing, or approval.
      - `proof.id` (number)
        Proof ID of the proof version.
      - `proof.originalId` (number)
        Proof ID of the original proof version.
      - `proof.name` (string)
        Proof name. This is the same as primary column value. If the primary column value is empty, name is empty.
      - `proof.type` (string)
        File type for the proof version.
        Enum: same as `proof.type` in "Row" (5 values)
      - `proof.documentType` (string)
        If type=DOCUMENT, then this indicates the type of file, such as PDF.
      - `proof.proofRequestUrl` (string)
        URL to review a proofing request.
      - `proof.version` (number)
        The version number of the proof.
      - `proof.lastUpdatedBy` (object)
        User object containing name and email of the user who last updated the proof.
      - `proof.lastUpdatedBy.email` (string)
        Example: "jane.doe@smartsheet.com"
      - `proof.isCompleted` (boolean)
        Indicates whether the proof is completed.
      - `proof.attachments` (array)
        Array of Attachment objects. Only returned if the include query string parameter contains attachments.
      - `proof.discussions` (array)
        Array of Discussion objects. Only returned if the include query string parameter contains discussions.
      - `format` (string)
        Format descriptor. Only returned if the include query string parameter contains format and this row has a non-default format applied.

Refer to [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting), for format descriptor details.
        Example: ",,1,1,,,,,,,,,,,,,"
      - `inCriticalPath` (boolean)
        Only returned, with a value of true, if the sheet is a project sheet with dependencies enabled and this row is in the critical path.
      - `locked` (boolean)
        Indicates whether the row is locked.
      - `lockedForUser` (boolean)
        Indicates whether the row is locked for the requesting user.

## Response 200 fields (application/json):

  - `message` (string)
    Message that indicates the outcome of the request. (One of SUCCESS or PARTIAL_SUCCESS.)
    Enum: "PARTIAL_SUCCESS", "SUCCESS"

  - `resultCode` (number)
    * '0' Success
* '3' Partial Success of Bulk Operation
    Enum: 0, 3

  - `result` (array)

  - `result.id` (number)
    Row ID.

  - `result.sheetId` (number)
    Parent sheet ID.

  - `result.rowNumber` (number)
    Row number within the sheet.

  - `result.expanded` (boolean)
    Indicates whether the row is expanded or collapsed.

  - `result.createdAt` (any)

  - `result.modifiedAt` (any)

  - `result.cells` (array)
    Cells objects.

  - `result.cells.columnId` (number)
    The ID of the column that the cell is located in.

  - `result.cells.columnType` (string)
    Only returned if the include query string parameter contains columnType.

  - `result.cells.value` (any)
    A string, number, or a Boolean value -- depending on the cell type and the data in the cell. Cell values larger than 4000 characters are silently truncated. An empty cell returns no value.

  - `result.cells.displayValue` (string)
    Visual representation of cell contents, as presented to the user in the UI.

  - `result.version` (number)
    Sheet version number that is incremented every time a sheet is modified.

## Response default fields (application/json):

  - `refId` (string)
    The ID of the specific error occurrence. Please include this information when contacting Smartsheet support.

  - `errorCode` (number)
    Custom error code from Smartsheet. See the complete [Error Code List](/api/smartsheet/error-codes).

  - `message` (string)
    Descriptive error message.


## Response 400 fields
